import type { Route } from './+types/root'

import {
  isRouteErrorResponse,
  Links,
  Meta,
  Outlet,
  Scripts,
  ScrollRestoration
} from 'react-router'

import { loggingMiddleware } from '@repo/auth/middleware/logging'
import { ThemeProvider } from '@repo/ui/components/theme-provider'
import './app.css'

export const middleware: Route.MiddlewareFunction[] = [loggingMiddleware]

export function Layout({ children }: { children: React.ReactNode }) {
  const rybbitSiteId = '83748b35413d'

  return (
    <html lang="pt-br" suppressHydrationWarning>
      <head>
        <meta charSet="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <link rel="icon" type="image/svg+xml" href="/favicon.svg" />
        <title>admin.saladeaula.digital</title>
        <Meta />
        <Links />
        {/* Rybbit Tracking Snippet */}
        <script
          src="https://analytics.eduseg.com.br/api/script.js"
          data-site-id={rybbitSiteId}
          async
          defer
        ></script>
      </head>
      <body>
        <ThemeProvider
          attribute="class"
          defaultTheme="system"
          enableSystem
          disableTransitionOnChange
        >
          {children}
          <ScrollRestoration />
          <Scripts />
        </ThemeProvider>
      </body>
    </html>
  )
}

export default function App() {
  return <Outlet />
}

export function ErrorBoundary({ error }: Route.ErrorBoundaryProps) {
  let message = 'Oops!'
  let details = 'Ocorreu um erro inesperado.'
  let stack: string | undefined

  if (isRouteErrorResponse(error)) {
    message = error.status === 404 ? '404' : 'Erro'
    details =
      error.status === 404
        ? 'A página solicitada não foi encontrada.'
        : error.statusText || details
  } else if (import.meta.env.DEV && error && error instanceof Error) {
    details = error.message
    stack = error.stack
  }

  console.error({ message, details, stack })

  return (
    <main className="pt-16 p-4 container mx-auto">
      <h1>{message}</h1>
      <p>{details}</p>
      {stack && (
        <pre className="w-full p-4 overflow-x-auto">
          <code>{stack}</code>
        </pre>
      )}
    </main>
  )
}
